let world;
let obj;
let obj2;
let left2_bubble;
let left2_bubble_img;
let right_bubble;
let right_bubble_img;
let left2_face;
let right_face;
let button;
let button_img;
let pressed_button_img;
let mooshroom;
let mooshroom_img;
let bg;
let is_playing = true;
let world2;
let post;
let post_img;
let telegraph;
let telegraph_img;
let is_ended = false;
let is_world2_playing = false;
let end_message = "In a split moment there was nothing... No radio, no TV, no internet... No facebook, no twitter...";
let end_message2 = "But in a post office, in a village far, far away - there was a preserved technology, that could save the world...";
let angry_snd;
let press_snd;
let kaboom;

function isTouchDevice() {
    return 'ontouchstart' in window        // works on most browsers 
        || 'onmsgesturechange' in window;  // works on IE10 with some false positives
  };

function mousePressed(){
	// TODO: see how to fix this for touch devices
	return;
	if(isTouchDevice()) {
		return;
	}
	console.log(world2.frame);
  if(is_playing){
    is_playing = false;
  } else {
    is_playing = true;
  }
  if(is_world2_playing == false && is_ended){
    is_world2_playing = true;
  } else {
    is_world2_playing = false;
  }
}

/*
function touchEnded(){
	console.log(world2.frame);
  if(is_playing){
    is_playing = false;
  } else {
    is_playing = true;
  }
  if(is_world2_playing == false && is_ended){
    is_world2_playing = true;
  } else {
    is_world2_playing = false;
  }
}
*/

function setupAnimation(){
  world = new World();
  obj = new Obj(0,height/2);
  obj.behavior.push(new FromToMovement(0,75,-75,height/2,width/2-150,height/2));
  obj2 = new Obj(width,height/2);
  obj2.behavior.push(new FromToMovement(150,225,width+75,height/2,width/2+150,height/2));
  left2_bubble = new Obj(width/2-50,height/2-50);
  left2_bubble.behavior.push(new ShowAndHide(75,150));
  right_bubble = new Obj(width/2+100,height/2-50);
  right_bubble.behavior.push(new ShowAndHide(225,300));
  button = new Obj(width/2-150,height+50);
  button.behavior.push(new FromToMovement(300,350,width/2-150,height+50,width/2-150,height-200));
  mooshroom = new Obj(width/2,height);
  mooshroom.behavior.push(new ShowAndHide(500,595));
  mooshroom.behavior.push(new FromToMovement(500,600,200,200,width,height));
  world.addObject(obj);
  world.addObject(obj2);
  world.addObject(left2_bubble);
  world.addObject(right_bubble);
  world.addObject(button);
  world.addObject(mooshroom);
}

function preload(){
  left2_face = loadImage("src/img/left.png");
  right_face = loadImage("src/img/right.png");
  left2_bubble_img = loadImage("src/img/left2_bubble.png");
  right_bubble_img = loadImage("src/img/right_bubble.png");
  button_img = loadImage("src/img/pressed_button.png");
  pressed_button_img = loadImage("src/img/button.png");
  mooshroom_img = loadImage("src/img/mooshroom.png");
  bg = loadImage("src/img/background.jpg");
  post_img = loadImage("src/img/hopepost.png");
  telegraph_img = loadImage("src/img/telegraph.png");
  angry_snd = loadSound("src/snd/angry.mp3");
  press_snd = loadSound("src/snd/press.mp3");
  kaboom = loadSound("src/snd/kaboom.mp3");
}

function setup(){
	
  if(windowWidth > 800 || windowHeight > 600){
    createCanvas(800,600);
  } else {
    createCanvas(windowWidth,windowHeight);
  }
  setupAnimation();
  world2 = new World();
  post = new Obj(width/2,height);
  post.behavior.push(new FromToMovement(0,120,width/2,height,width/2,height/2));
  world2.addObject(post);
  telegraph = new Obj(width/2,height-125);
  telegraph.behavior.push(new FromToMovement(822,942,width/2,height+125,width/2,height/2));
  world2.addObject(telegraph);
  left2_face.resize(150,150);
  right_face.resize(150,150);
  left2_bubble_img.resize(100,100);
  button_img.resize(100,100);
  pressed_button_img.resize(100,100);
  post_img.resize(width,height);
  telegraph_img.resize(200,250);
  setupSpeech('Google UK English Male');
  frameRate(60);
}

function draw(){
	angry_snd.setVolume(10);
	kaboom.setVolume(10);
  if(world.frame == 75){
    angry_snd.play();
  } else if (world.frame == 225){
    angry_snd.play();
  } else if (world.frame == 451){
    press_snd.play();
  } else if (world.frame == 500){
    kaboom.play();
  }
  background(51);
  //console.log(world.frame);
  bg.resize(width,height);
  image(bg,width/2,height/2);
  //filter(GRAY);
  imageMode(CENTER);
  textAlign(CENTER);
  if(world.frame < 599 && is_playing){
    world.nextFrame();
  }
  mooshroom_img.resize(mooshroom.x,mooshroom.y);
  image(left2_face,obj.x,obj.y);
  image(right_face,obj2.x,obj2.y);
  mooshroom.y = height - (mooshroom_img.height/2);
  mooshroom.x = width/2;
  //console.log(button.y);
  if(left2_bubble.visible){
    image(left2_bubble_img,left2_bubble.x,left2_bubble.y);
    text("#$!@#*$",left2_bubble.x,left2_bubble.y-5);
  }
  if(right_bubble.visible){
    image(right_bubble_img,right_bubble.x,right_bubble.y);
    text("#$!#$@*#",right_bubble.x,right_bubble.y-5);
  }
  image(button_img,button.x,button.y);
  image(button_img,button.x+300,button.y);
  if (world.frame > 450 && world.frame < 470){
    image(pressed_button_img,button.x,button.y);
    image(pressed_button_img,button.x+300,button.y);
  }
  if(mooshroom.visible){
    image(mooshroom_img,mooshroom.x,mooshroom.y);
  }
  if(world.frame > 598){
    filter(GRAY);
    fill(255,0,0);
    textSize(70);
	textFont("Courier New");
	textStyle(BOLD);
    text("GAME OVER",width/2,height/2);
	is_world2_playing = true;
    is_ended = true;
  }
  if(is_world2_playing){
	world2.nextFrame();
    image(post_img,post.x,post.y);
    image(telegraph_img,telegraph.x,telegraph.y);
    if(world2.frame == 100){
      say(end_message,1,0.8);
      say(end_message2,1,1);
    }
  }
}
